package framework.jstl;

import java.util.List;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.servlet.tags.RequestContextAwareTag;

import pathtree.model.PathTree;
import pathtree.service.PathTreeService;

public class PathTreeTag extends RequestContextAwareTag {
	private static final long serialVersionUID = 3784999898165509699L;

	private String id;
	private PathTreeService pathTreeService;

	public void setId(String id) {
		this.id = id;
	}

	@Override
	protected int doStartTagInternal() throws Exception {
		if (pathTreeService == null) {
			WebApplicationContext ctx = getRequestContext().getWebApplicationContext();
			pathTreeService = ctx.getBean(PathTreeService.class);
		}

		StringBuffer sb = new StringBuffer();

		// 여기서부터 바로 printChildren 시작해도 되나
		// 입력 받은 id 를 적용하기 위해 한번 돌림
		sb.append("<ul id=\"");
		sb.append(id);
		sb.append("\">");

		List<PathTree> roots = pathTreeService.getRoots();
		for (PathTree pt : roots) {
			sb.append("<li id=\"");
			sb.append(pt);
			sb.append("\">");
			sb.append(pt);
			printChildren(sb, pt.getChildren());
			sb.append("</li>");
		}

		sb.append("</ul>");

		pageContext.getOut().write(sb.toString());

		return SKIP_BODY;
	}

	// 재귀
	private void printChildren(StringBuffer sb, List<PathTree> children) {
		for (PathTree pt : children) {
			sb.append("<ul>");
			sb.append("<li id=\"");
			sb.append(pt.getId());
			sb.append("\">");
			sb.append(pt);
			sb.append("</li>");
			// 재귀
			printChildren(sb, pt.getChildren());
			sb.append("</ul>");
		}
	}

}
