package pathtree.dao;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;
import org.springframework.stereotype.Repository;

import pathtree.model.PathTree;

import com.ibatis.sqlmap.client.SqlMapClient;

@Repository("pathTreeDao")
public class PathTreeDao extends SqlMapClientDaoSupport {

	@Autowired
	public PathTreeDao(SqlMapClient sqlMapClient) {
		super.setSqlMapClient(sqlMapClient);
	}
	
	@SuppressWarnings("unchecked")
	public List<PathTree> selectRoot() {
		return getSqlMapClientTemplate().queryForList("pathtree.sqlmap.PathTree.selectRoot");
	}
	
	@SuppressWarnings("unchecked")
	public List<PathTree> selectByParentPath(String path) {
		return getSqlMapClientTemplate().queryForList("pathtree.sqlmap.PathTree.selectByParentPath", path);
	}
	
}
