package pathtree.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class PathTree implements Serializable {
	private static final long serialVersionUID = 6587463436380309327L;

	private int id;
	private String path;
	private List<PathTree> children = new ArrayList<PathTree>();

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}

	public String getFullPath() {
		return path + id + "/";
	}

	public List<PathTree> getChildren() {
		return children;
	}

	public void setChildren(List<PathTree> children) {
		this.children = children;
	}

	@Override
	public String toString() {
		return "PathTree [id=" + id + ", parent path=" + path + ", my path=" + getFullPath() + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PathTree other = (PathTree) obj;
		if (id != other.id)
			return false;
		return true;
	}

}
