package pathtree.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import pathtree.dao.PathTreeDao;
import pathtree.model.PathTree;

@Service("pathTreeService")
public class PathTreeService {

	@Autowired
	private PathTreeDao pathTreeDao;

	public List<PathTree> getRoots() {
		List<PathTree> roots = pathTreeDao.selectRoot();
		for (PathTree pt : roots) {
			findChildren(pt);
		}
		
		return roots;
	}

	// 재귀
	private void findChildren(PathTree pt) {
		List<PathTree> children = pathTreeDao.selectByParentPath(pt.getFullPath());
		pt.setChildren(children);
		
		for (PathTree c : pt.getChildren()) {
			findChildren(c);
		}
	}
	
}
